
#PB_ProgressBarEx_Single  =$001
#PB_ProgressBarEx_Flat    =$002
#PB_ProgressBarEx_Default =$003
#PB_ProgressBarEx_Vertical=$010
#PB_ProgressBarEx_Img     =$100
#PB_ProgressBarEx_NoBKColor=-1

Structure SpecArray 
  value.f[512] 
EndStructure 

Procedure Spec(value.l) 
   Repeat
    If FSOUND_DSP_GetActive(FSOUND_DSP_GetFFTUnit()) 
        CopyMemory(FSOUND_DSP_GetSpectrum(),hSpec.SpecArray,4*512) 
    EndIf 
    For i = 0 To 127
      SetProgressBarEx(i,(199-Pow(0.0000001,hSpec\value[i])*199)) 
    Next i 
  ForEver
EndProcedure 


If OpenWindow(0, 0, 0, 516,132, #PB_Window_SystemMenu | #PB_Window_ScreenCentered, "Spectrum with ProgressBarEx") 
  If CreateGadgetList(WindowID()) 
    InitProgressBarEx(WindowID()) 
    For i = 0 To 127 
      ProgressBarEx(i,1+i*4,2,5,128,0,200,RGB(255,0,0),RGB(255,255,0),#PB_ProgressBarEx_NoBKColor,0,#PB_ProgressBarEx_Vertical|#PB_ProgressBarEx_Flat) 
    Next i 
  EndIf 
EndIf 

File$ = OpenFileRequester("Open SoundFile","c:\*.mp3","*.mp3",0)

FSOUND_SetBufferSize(125) 
If FSOUND_Init(44100, 32, 0) 
  File = FSOUND_Stream_Open(File$, 2, 0,0) 
  FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(), #TRUE) 
  FSOUND_Stream_Play(0,File) 
EndIf 

ThreadID = CreateThread(@Spec(),0) 

Repeat 
Until  WaitWindowEvent()=#PB_Event_CloseWindow

KillThread(ThreadID) 
FSOUND_Stream_Stop(File) 
FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(), #FALSE) 
FSOUND_Close() 
End



; ExecutableFormat=Windows
; CursorPosition=28
; FirstLine=1
; DisableDebugger
; EOF